using System;
using System.ComponentModel;
using Itgmbh.Elvis.CustomBehaviour;
using System.Globalization;

[ActiveItem]
public class TimeSettingCI
{
    public TimeSettingCI()
    {
        Output = _dateTime;
        DisplayDateTime();
    }

    private DateTime _dateTime = DateTime.Now;

    // Inputs
    [Input]
    public bool YearUp { get; set; }
    [Input]
    public bool YearDown { get; set; }
    [Input]
    public bool MonthUp { get; set; }
    [Input]
    public bool MonthDown { get; set; }
    [Input]
    public bool DayUp { get; set; }
    [Input]
    public bool DayDown { get; set; }

    [Input]
    public bool HourUp { get; set; }
    [Input]
    public bool HourDown { get; set; }
    [Input]
    public bool MinuteUp { get; set; }
    [Input]
    public bool MinuteDown { get; set; }
    [Input]
    public bool SecondUp { get; set; }
    [Input]
    public bool SecondDown { get; set; }

    [Input]
    public bool Done { get; set; }
    [Input]
    public bool Cancel { get; set; }

    // Outputs
    [Output]
    public int Year { get; set; }
    [Output]
    public int Month { get; set; }
    [Output]
    public int Day { get; set; }
    [Output]
    public int Hour { get; set; }
    [Output]
    public int Minute { get; set; }
    [Output]
    public int Second { get; set; }
    [Output]
    public DateTime Output { get; set; }
    [Output]
    public string OutputString { get; set; }

    // Optional: Parameters
    // [Parameter, DefaultValue(0)]
    // public int Parameter1 { get; set; }

    // Optional: Initialization/Termination
    // public void Control(ICustomItemCallContext context)
    // {
    // }

    // Script Body
    public void Execute(ICustomItemCallContext context)
    {
        if (YearUp)
            _dateTime = _dateTime.AddYears(1);
        else if (YearDown)
            _dateTime = _dateTime.AddYears(-1);
        else if (MonthUp)
            _dateTime = _dateTime.AddMonths(1);
        else if (MonthDown)
            _dateTime = _dateTime.AddMonths(-1);
        else if (DayUp)
            _dateTime = _dateTime.AddDays(1);
        else if (DayDown)
            _dateTime = _dateTime.AddDays(-1);
        else if (HourUp)
            _dateTime = _dateTime.AddHours(1);
        else if (HourDown)
            _dateTime = _dateTime.AddHours(-1);
        else if (MinuteUp)
            _dateTime = _dateTime.AddMinutes(1);
        else if (MinuteDown)
            _dateTime = _dateTime.AddMinutes(-1);
        else if (SecondUp)
            _dateTime = _dateTime.AddSeconds(1);
        else if (SecondDown)
            _dateTime = _dateTime.AddSeconds(-1);
        else if (Done)
        {
            Output = _dateTime;
            OutputString = _dateTime.ToString("yyyy/MM/dd HH:mm:ss", CultureInfo.InvariantCulture);
        }
        DisplayDateTime();

    }

    private void DisplayDateTime()
    {
        Year = _dateTime.Year;
        Month = _dateTime.Month;
        Day = _dateTime.Day;
        Hour = _dateTime.Hour;
        Minute = _dateTime.Minute;
        Second = _dateTime.Second;
    }
}
